from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('SIBWSInboundPortReference')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereSIBWSInboundPortReference");
  exportedObject.put("roleName", "WebSphereSIBWSInboundPortReference");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.sibwsinboundportreference.servicename", objid, "serviceName","SIBWSInboundPortReference");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.sibwsinboundportreference.busname", objid, "busName","SIBWSInboundPortReference");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.sibwsinboundportreference.portname", objid, "portName","SIBWSInboundPortReference");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('SIBWSInboundPortReference');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('SIBWSInboundPortReference')
  if not jsonobject.has("roleProperties"):
    raise Exception("SIBWSInboundPortReference resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "serviceName", roleProperties.optString("websphere.sibwsinboundportreference.servicename", None));
  Util.addIfNotNone(properties, "busName", roleProperties.optString("websphere.sibwsinboundportreference.busname", None));
  Util.addIfNotNone(properties, "portName", roleProperties.optString("websphere.sibwsinboundportreference.portname", None));
  print "Creating SIBWSInboundPortReference with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("SIBWSInboundPortReference", parentid, properties);
  Util.popPathElement('SIBWSInboundPortReference');

def update(objid,jsonobject):
  Util.pushPathElement('SIBWSInboundPortReference')
  if not jsonobject.has("roleProperties"):
    raise Exception("SIBWSInboundPortReference resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.sibwsinboundportreference.servicename", None), "serviceName","SIBWSInboundPortReference");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.sibwsinboundportreference.busname", None), "busName","SIBWSInboundPortReference");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.sibwsinboundportreference.portname", None), "portName","SIBWSInboundPortReference");
  if len(atts) != 0:
    print "Modifying SIBWSInboundPortReference with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "SIBWSInboundPortReference configuration up to date.";

  Util.popPathElement('SIBWSInboundPortReference');
